package com.shafaat.apps.mouse.mover;

import org.h2.tools.Server;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;

import javax.annotation.PostConstruct;
import java.sql.SQLException;

@SpringBootApplication
public class MouseMoverApplication {

    public static void main(String[] args) {
        System.setProperty("java.awt.headless", "false");
        SpringApplication.run(MouseMoverApplication.class, args);
    }

    @PostConstruct
    public void setFalseHeadless(){
        System.setProperty("java.awt.headless", "false");
    }

    @Bean(initMethod = "start", destroyMethod = "stop")
    public Server h2Server() throws SQLException {
        return Server.createTcpServer("-tcp", "-tcpAllowOthers", "-tcpPort", "6603");
    }

}
