package com.shafaat.apps.mouse.mover.service;

import com.shafaat.apps.mouse.mover.common.ConfigKeysEnum;
import com.shafaat.apps.mouse.mover.entity.Config;
import com.shafaat.apps.mouse.mover.repo.ConfigRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.Optional;

@Service
public class ConfigService {

    @Autowired
    private ConfigRepo repo;


    public void setStopFlag(Boolean status){
        Optional<Config> row = repo.findByKey(ConfigKeysEnum.STOP_FLAG.name());
        if(row.isPresent()){
            Config stopRow = row.get();
            stopRow.setValue(String.valueOf(status));
            repo.save(stopRow);
        }
    }

    public void setRunningFlag(Boolean status){
        Optional<Config> row = repo.findByKey(ConfigKeysEnum.IS_RUNNING.name());
        if(row.isPresent()){
            Config runningRow = row.get();
            runningRow.setValue(String.valueOf(status));
            repo.save(runningRow);
        }
    }

    public Boolean getStopFlag(){
        Optional<Config> row = repo.findByKey(ConfigKeysEnum.STOP_FLAG.name());
        if(row.isPresent()){
            Config stopRow = row.get();
            return Boolean.valueOf(stopRow.getValue());
        }
        return false;
    }

    public Boolean isRunning(){
        Optional<Config> row = repo.findByKey(ConfigKeysEnum.IS_RUNNING.name());
        if(row.isPresent()){
            Config runningRow = row.get();
            return Boolean.valueOf(runningRow.getValue());
        }
        return false;
    }

    @PostConstruct
    public void setConfigsOnInit(){

        Config isRunning = new Config();
        isRunning.setKey(ConfigKeysEnum.IS_RUNNING.name());
        isRunning.setValue(String.valueOf(Boolean.FALSE));

        Config stopFlag = new Config();
        stopFlag.setKey(ConfigKeysEnum.STOP_FLAG.name());
        stopFlag.setValue(String.valueOf(Boolean.FALSE));

        repo.save(isRunning);
        repo.save(stopFlag);
    }

}
