package com.shafaat.apps.mouse.mover.service;

import com.shafaat.apps.mouse.mover.repo.ConfigRepo;
import org.sikuli.script.Env;
import org.sikuli.script.Screen;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.Instant;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

@Service
public class MouseMoverService {

    @Autowired
    private ConfigService configService;

    public void moveMouse(){

        if(configService.isRunning()){
            System.out.println("The process is already running");
            return;
        }

        int totalMins = 30;
        System.out.println("Starting to move for " + totalMins + " mins @ " + DateTimeFormatter.ofPattern("HH:mm:ss").format(LocalDateTime.now()));

        Screen screen = new Screen();
        int totalHeight = screen.getBounds().height;
        int totalWidth = screen.getBounds().width;

        System.out.println(totalHeight + " " + totalWidth);

        int totalSecs = totalMins * 60;

        int totalMilliSecs = totalSecs * 1000;

        int noOfTimes = 0;

        for(int i = 0; i <= totalMilliSecs; i=i+15000){

            if(configService.getStopFlag()){
                break;
            }

            noOfTimes++;

            int currentX = Env.getMouseLocation().x;
            int currentY = Env.getMouseLocation().y;


            System.out.println(currentX + " ------------- " + currentY + " @ " + DateTimeFormatter.ofPattern("HH:mm:ss").format(LocalDateTime.now()) + " :: round# " + noOfTimes);

            int xOff = (int) ((Math.random() * (200 - 1) ) + 1);
            int yOff = (int) ((Math.random() * (200 - 1) ) + 1);



            if( currentX > (totalWidth - 201) ){
                xOff = -currentX+50;
            }

            if( currentY > (totalHeight - 201) ){
                yOff = -currentY+50;
            }


            screen.mouseMove(xOff, yOff);

            try {
                Thread.sleep(15000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        configService.setStopFlag(Boolean.FALSE);
        configService.setRunningFlag(Boolean.FALSE);
    }

}
